<?php

/**
 * comisionado_obj actions.
 *
 * @package    controlComisiones
 * @subpackage comisionado_obj
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class comisionado_objActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_COMISIONADO_OBJ','COM_COMISION', 'PROYECTOS', 'TIPOS_COMISION','AREA','COM_TIPO_DESTINO','COM_TERCERO','COM_TIPO_COMISIONADO','OBJETOS_GASTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_COMISION'=>
        array(
            'id_comision' => 'COM_COMISIONADO_OBJ'
        )
        ,'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
           'id_tipo_comision' => 'COM_COMISION'
        ),
        'AREA' =>
        array(
            'id_area' => 'COM_COMISION'
        ),
        'COM_TIPO_DESTINO' =>
        array(
           'id_tipo_destino' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_COMISIONADO_OBJ'
        ),
        'COM_TIPO_COMISIONADO' =>
        array(
            'tipter' => 'COM_TERCERO'
        ),
        'OBJETOS_GASTO' =>
        array(
            'id_obj_gasto-id' => 'COM_COMISIONADO_OBJ'
        )
        
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_COMISIONADO_OBJ' =>
        array(
            'id_comisionado_obj' => 'id_comisionado_obj',
            'id_comision' => 'id_comision',
            'id_tercero' => 'id_tercero',
            'id_obj_gasto' => 'id_obj_gasto',
            'valor' => 'valor',
            'observaciones' => 'observaciones',
            'porc_iva' => 'porc_iva',
            'valor_iva' => 'valor_iva'
        )
        ,
        'COM_COMISION' =>
        array(
            'id_anhos' => 'id_anhos',
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'id_tipo_destino' => 'id_tipo_destino',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_fin' => 'fecha_fin',
            'id_area' => 'id_area',
            'id_tipo_comision' => 'id_tipo_comision',
            'id_original' => 'id_original',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'activo' => 'activo'
        )
        ,
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'TIPOS_COMISION' =>
        array(
            'descripcion' => 'tipo_comision'
        ),
        'AREA' =>
        array(
            'descripcion' => 'area'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'descripcion' => 'tipo_destino'
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre',
            'email' => 'email'
        ),
        'OBJETOS_GASTO' =>
        array(
            'codigo' => 'codigo_obj',
            'descripcion' => 'descripcion_obj',
            'viatico' => 'viatico',
            'viaje' => 'viaje'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_COMISIONADO_OBJ' =>
        array(
            'id_comisionado_obj,a' => array('!=' => array(-1)),
            'id_comisionado_obj,b' => array('=' => array('id_comisionado_obj')),
            'id_comision' => array('=' => array('id_comision')),
            'id_tercero' => array('=' => array('id_tercero')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'OBJETOS_GASTO' =>
        array(
            'viatico' => array('=' => array('viatico')),
            'viaje' => array('=' => array('viaje')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_comisionado_obj'; //identificador de la tabla
    protected $id_names = array('id_comisionado_obj'); //llave primaria
    protected $field_names = array('id_comision','id_tercero','id_obj_gasto','valor','observaciones','porc_iva','valor_iva'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_COMISIONADO_OBJ'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_comisionado_obj'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            $this->actualizarComisionadoImp($request['id_tercero'],$request['id_comision']);
        }

        //accion update
        if ($Action == "UPDATE") {
            $this->actualizarComisionadoImp($request['id_tercero'],$request['id_comision']);
        }

        //accion remove
        if ($Action == "REMOVE") {
            $this->actualizarComisionadoImp($request['id_tercero'],$request['id_comision']);
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            //20170516 validamos que el tercero es de regimen comun (aplica iva) y nos traemos los valores correspondientes y calculamos
            $id_tercero = $request['id_tercero'];
            $sql = <<<EOD
select * from com_tercero where id_tercero = $id_tercero
EOD;
            $records = CN_TABLE::executeSQL($sql);
            $aplica_iva = $records[0]['aplica_iva'];
            $porcentaje_iva = $records[0]['porcentaje_iva'];
            
            if ($aplica_iva == "1" || $aplica_iva == 1 || $aplica_iva == true || $aplica_iva == "true") {
                $valor=$request['valor'];
                $request['porc_iva']=$porcentaje_iva;
                //$request['valor_iva']=($valor*$porcentaje_iva)/100;
                $request['valor_iva']=$valor-round($valor/(1+$porcentaje_iva/100));
             }
        }

        //accion update
        if ($Action == "UPDATE") {
            //20170516 validamos que el tercero aplique iva y nos traemos los valores correspondientes y calculamos
            $id_tercero = $request['id_tercero'];
            $sql = <<<EOD
select * from com_tercero where id_tercero = $id_tercero
EOD;
            $records = CN_TABLE::executeSQL($sql);
            $aplica_iva = $records[0]['aplica_iva'];
            $porcentaje_iva = $records[0]['porcentaje_iva'];
            if ($aplica_iva == "1" || $aplica_iva == 1 || $aplica_iva == true || $aplica_iva == "true") {
                $valor=$request['valor'];
                $request['porc_iva']=$porcentaje_iva;
                //$request['valor_iva']=($valor*$porcentaje_iva)/100;
                $request['valor_iva']=$valor-round($valor/(1+$porcentaje_iva/100));
             }
        }

        //accion remove
        if ($Action == "REMOVE") {
            $id_comis_obj=$request['id_comisionado_obj'];
            $sql = <<<EOD
select * from com_comisionado_obj where id_comisionado_obj = $id_comis_obj
EOD;
            $records = CN_TABLE::executeSQL($sql);
            $request['id_tercero'] = $records[0]['id_tercero'];
            $request['id_comision'] = $records[0]['id_comision'];
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_comision = $request['id_comision'];
        $id_tercero = $request['id_tercero'];
        
        $sql = <<<EOD
select count(id_comisionado) cantidad from com_comisionado where id_comision = $id_comision and id_tercero=$id_tercero
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];


        if ($cantidad == 0) {

            $errors['mensaje'] = "El Comisionado no se encuentra programado en esta comision, no se puede asociar el gasto";
            $errors['servicio'] = "comisionado_obj";
        }

        //20170530 se valida que la comision no tenga cuenta para poder registrar nuevos gastos
        $sql = <<<EOD
select cc.* from com_cuenta cc join com_resolucion cr on cc.ID_RESOLUCION=cr.ID_RESOLUCION where cr.id_comision= $id_comision and cc.estado<>0
EOD;

        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {

            $errors['mensaje'] = "La comision ya posee una cuenta asociada, No se pueden registrar Gastos";
            $errors['servicio'] = "tiquete";
        }

        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;
        
        $id_comisionado_obj=$request['id_comisionado_obj'];
        /*
         *  Validar la operación, ya sea por SQL
         */
        //20170530 se valida que la comision no tenga cuenta para poder eliminar los gastos ya existentes
        $sql = <<<EOD
SELECT cc.*
FROM com_cuenta cc
JOIN com_resolucion cr
ON cc.ID_RESOLUCION =cr.ID_RESOLUCION
JOIN com_comision comis on comis.ID_COMISION=cr.ID_COMISION
join com_comisionado_obj cco on cco.ID_COMISION=comis.ID_COMISION
WHERE cco.ID_COMISIONADO_OBJ= $id_comisionado_obj and cc.estado<>0
EOD;

        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {

            $errors['mensaje'] = "La comision ya posee una cuenta asociada, No se pueden eliminar gastos";
            $errors['servicio'] = "tiquete";
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        
        
        
        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
    //20170516 Funcion para actualizar la tabla de comisionado Imp borra los registros del tercero y la comision y los recalcula
    public function actualizarComisionadoImp($idtercero,$idcomision) {
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {
            //20170516 proceso para recalcular los Impuestos Iva e ICA 
                $id_tercero = $idtercero;
                $id_comision = $idcomision;
                $sql = <<<EOD
    select * from com_tercero where id_tercero = $id_tercero
EOD;
                $records = CN_TABLE::executeSQL($sql);
                $aplica_iva = $records[0]['aplica_iva'];
                $aplica_ica=$records[0]['aplica_ica'];
                //Si aplica IVA proceso de generar de retenciones de iva
                if ($aplica_iva == "1" || $aplica_iva == 1 || $aplica_iva == true || $aplica_iva == "true") {
                    //buscamos el codigo del reteIVA para control de comisiones
                    $sql = <<<EOD
select * from com_param_control_comis where parametro = 'COD_IMP_RETIVA'
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    $codimp = $records[0]['valor'];
                    //Obtenemos el porcentaje
                    $sql = <<<EOD
select * from ts_im where id= $codimp
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    $porcentaje = $records[0]['porcentaje'];

                    //Borramos todos los registros de impuestos de la comision referente a IVA
                    $sql = <<<EOD
DELETE from com_comisionado_imp where id_comision = $id_comision and id_tercero=$id_tercero and id_ts_im=$codimp
EOD;
                    $this->conn->execute($sql);
                    $sql = <<<EOD
select sum(valor) as valor,sum(valor_iva) as valor_iva from com_comisionado_obj where id_comision = $id_comision and id_tercero=$id_tercero
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    $valor_base = $records[0]['valor_iva'];
                    $valor=round(($valor_base*$porcentaje)/100);
                    $sql = <<<EOD
            INSERT INTO COM_COMISIONADO_IMP (ID_COMISION,ID_TERCERO,ID_TS_IM,PORCENTAJE,VALOR_BASE,VALOR_IMP)
               VALUES($id_comision,$id_tercero,$codimp,$porcentaje,$valor_base,$valor)
EOD;
                    $this->conn->execute($sql);
                }
                //Desde aqui reencion del ICA
                if ($aplica_ica == "1" || $aplica_ica == 1 || $aplica_ica == true || $aplica_ica == "true") {
                    //buscamos el codigo del reteICA para control de comisiones
                    $sql = <<<EOD
select * from com_param_control_comis where parametro = 'COD_IMP_RETICA'
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    $codimp = $records[0]['valor'];
                    //Obtenemos el porcentaje
                    $sql = <<<EOD
select * from ts_im where id= $codimp
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    $porcentaje = $records[0]['porcentaje'];

                    //Borramos todos los registros de impuestos de la comision referente a IVA
                    $sql = <<<EOD
DELETE from com_comisionado_imp where id_comision = $id_comision and id_tercero=$id_tercero and id_ts_im=$codimp
EOD;
                    $this->conn->execute($sql);
                    $sql = <<<EOD
select sum(valor) as valor,sum(valor_iva) as valor_iva from com_comisionado_obj where id_comision = $id_comision and id_tercero=$id_tercero
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    $valor_base =$records[0]['valor']- $records[0]['valor_iva'];
                    $valor=round(($valor_base*$porcentaje)/100);
                    $sql = <<<EOD
            INSERT INTO COM_COMISIONADO_IMP (ID_COMISION,ID_TERCERO,ID_TS_IM,PORCENTAJE,VALOR_BASE,VALOR_IMP)
               VALUES($id_comision,$id_tercero,$codimp,$porcentaje,$valor_base,$valor)
EOD;
                 $this->conn->execute($sql);
                }
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
            return null;
    }
}
